'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

require('./button.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 09:57:51 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Button = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
  }

  _createClass(Button, [{
    key: 'handleClick',
    value: function handleClick(e) {
      if (this.props.onClick && !this.props.disabled) {
        this.props.onClick(e);
      }
    }
  }, {
    key: 'renderIcon',
    value: function renderIcon() {
      var icon = this.props.icon;

      return icon ? _react2.default.createElement('i', { className: (0, _classnames3.default)("iconfont", 'icon-' + icon) }) : null;
    }
  }, {
    key: 'renderSpan',
    value: function renderSpan() {
      var _props = this.props,
          name = _props.name,
          children = _props.children;

      return !!children || !!name ? _react2.default.createElement(
        'span',
        null,
        ' ',
        children || name,
        ' '
      ) : null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var _props2 = this.props,
          className = _props2.className,
          htmlType = _props2.htmlType,
          type = _props2.type,
          size = _props2.size,
          disabled = _props2.disabled,
          block = _props2.block,
          prefixCls = _props2.prefixCls,
          name = _props2.name,
          children = _props2.children,
          icon = _props2.icon,
          iconRight = _props2.iconRight;

      var clazzName = (0, _classnames3.default)((_classnames = {}, _defineProperty(_classnames, prefixCls + '-btn', true), _defineProperty(_classnames, prefixCls + '-btn-' + type, !!type), _defineProperty(_classnames, prefixCls + '-btn-' + size, !!size), _defineProperty(_classnames, prefixCls + '-icon-only', !children && !name && icon), _defineProperty(_classnames, prefixCls + '-btn-block', block), _defineProperty(_classnames, prefixCls + '-btn-disabled', disabled), _classnames), className);

      return !iconRight ? _react2.default.createElement(
        'button',
        {
          type: htmlType || 'button',
          className: clazzName,
          onClick: this.handleClick.bind(this)
        },
        this.renderIcon(),
        this.renderSpan()
      ) : _react2.default.createElement(
        'button',
        {
          type: htmlType || 'button',
          className: clazzName,
          onClick: this.handleClick.bind(this)
        },
        this.renderSpan(),
        this.renderIcon()
      );
    }
  }]);

  return Button;
}(_react2.default.Component);

Button.propTypes = {
  prefixCls: _react2.default.PropTypes.string,
  name: _react2.default.PropTypes.string,
  icon: _react2.default.PropTypes.string,
  iconRight: _react2.default.PropTypes.bool,
  type: _react2.default.PropTypes.oneOf(['primary', 'default', 'dashed', 'success', 'warning', 'danger']),
  size: _react2.default.PropTypes.oneOf(['large', 'small']),
  htmlType: _react2.default.PropTypes.string,
  disabled: _react2.default.PropTypes.bool,
  block: _react2.default.PropTypes.bool,
  className: _react2.default.PropTypes.string,
  children: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.node, _react2.default.PropTypes.element]),
  onClick: _react2.default.PropTypes.func
};
Button.defaultProps = {
  disabled: false,
  iconRight: false,
  prefixCls: 'ult'
};
exports.default = Button;