'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

require('./checkBox.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 09:59:16 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Radio = function (_React$Component) {
    _inherits(Radio, _React$Component);

    function Radio() {
        _classCallCheck(this, Radio);

        return _possibleConstructorReturn(this, (Radio.__proto__ || Object.getPrototypeOf(Radio)).apply(this, arguments));
    }

    _createClass(Radio, [{
        key: 'handleChange',
        value: function handleChange(e) {
            var _props = this.props,
                onChange = _props.onChange,
                disabled = _props.disabled,
                type = _props.type;

            if (disabled) {
                return;
            }
            if (onChange) {
                var value = e.currentTarget.value;
                onChange(value);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _classnames;

            var _props2 = this.props,
                className = _props2.className,
                title = _props2.title,
                name = _props2.name,
                value = _props2.value,
                defaultChecked = _props2.defaultChecked,
                checked = _props2.checked,
                disabled = _props2.disabled,
                prefixCls = _props2.prefixCls,
                inline = _props2.inline,
                btnStyle = _props2.btnStyle;

            var classes = (0, _classnames3.default)(prefixCls + '-checkbox', className, (_classnames = {}, _defineProperty(_classnames, prefixCls + '-checkbox-inline', inline), _defineProperty(_classnames, "checked", checked), _defineProperty(_classnames, "disabled", disabled), _classnames));
            if (btnStyle) {
                return _react2.default.createElement(
                    'label',
                    { className: (0, _classnames3.default)(prefixCls + '-btn', { "checked": checked, "disabled": disabled }) },
                    _react2.default.createElement('input', { type: 'radio', checked: checked, name: name, value: value, onChange: this.handleChange.bind(this), disabled: disabled }),
                    title
                );
            }
            return _react2.default.createElement(
                'label',
                { className: classes },
                _react2.default.createElement('span', { className: prefixCls + '-checkbox-inner ' + prefixCls + '-radio-type' }),
                _react2.default.createElement('input', { type: 'radio', checked: checked, name: name, value: value, onChange: this.handleChange.bind(this), disabled: disabled }),
                title
            );
        }
    }]);

    return Radio;
}(_react2.default.Component);

Radio.propTypes = {
    name: _react2.default.PropTypes.string.isRequired,
    onChange: _react2.default.PropTypes.func,
    checked: _react2.default.PropTypes.bool,
    disabled: _react2.default.PropTypes.bool,
    inline: _react2.default.PropTypes.bool,
    title: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.node, _react2.default.PropTypes.element]),
    prefixCls: _react2.default.PropTypes.string,
    className: _react2.default.PropTypes.string,
    btnStyle: _react2.default.PropTypes.bool
};
Radio.defaultProps = {
    inline: false,
    disabled: false,
    checked: false,
    prefixCls: "ult"
};
exports.default = Radio;