'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

require('rc-calendar/assets/index.css');

var _rcCalendar = require('rc-calendar');

var _rcCalendar2 = _interopRequireDefault(_rcCalendar);

var _Picker = require('rc-calendar/lib/Picker');

var _Picker2 = _interopRequireDefault(_Picker);

var _zh_CN = require('rc-calendar/lib/locale/zh_CN');

var _zh_CN2 = _interopRequireDefault(_zh_CN);

require('rc-time-picker/assets/index.css');

var _Panel = require('rc-time-picker/lib/Panel');

var _Panel2 = _interopRequireDefault(_Panel);

require('./datePicker.less');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

require('moment/locale/zh-cn');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 09:59:38 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var format = 'YYYY-MM-DD HH:mm:ss';

var now = (0, _moment2.default)();
now.locale('zh-cn').utcOffset(8);

function getFormat(time) {
  return time ? format : 'YYYY-MM-DD';
}

var defaultCalendarValue = now.clone();
// defaultCalendarValue.add(-1, 'month');

var timePickerElement = _react2.default.createElement(_Panel2.default, { defaultValue: (0, _moment2.default)('00:00:00', 'HH:mm:ss') });

function disabledTime() {
  var date = (0, _moment2.default)();
  var hh = date.hour();
  var disabledHH = [];
  for (var i = 0; i < hh; i++) {
    disabledHH.push(i);
  }
  return {
    disabledHours: function disabledHours() {
      return disabledHH;
    }
  };
}

function disabledDate(current) {
  if (!current) {
    // allow empty select
    return false;
  }
  var date = (0, _moment2.default)();
  date.hour(0);
  date.minute(0);
  date.second(0);
  return current.valueOf() < date.valueOf(); // can not select days before today
}

var DatePicker = function (_React$Component) {
  _inherits(DatePicker, _React$Component);

  function DatePicker(props) {
    _classCallCheck(this, DatePicker);

    var _this = _possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    _this.state = {
      value: _this.props.defaultValue
    };
    return _this;
  }

  _createClass(DatePicker, [{
    key: 'onChange',
    value: function onChange(value) {
      console.log('DatePicker change: ', value && value.format(getFormat(this.props.showTime)));
      this.setState({
        value: value
      });
    }
  }, {
    key: 'renderCalendar',
    value: function renderCalendar() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          showTime = _props.showTime,
          showDateInput = _props.showDateInput,
          isDisabledBefore = _props.isDisabledBefore;


      return _react2.default.createElement(_rcCalendar2.default, {
        className: prefixCls + '-datePicker-calendar',
        locale: _zh_CN2.default,
        style: { zIndex: 1000 },
        dateInputPlaceholder: '\u8BF7\u9009\u62E9...',
        formatter: getFormat(showTime),
        disabledDate: isDisabledBefore ? disabledDate : null,
        disabledTime: showTime ? disabledTime : null,
        timePicker: showTime ? timePickerElement : null
        // defaultValue={defaultCalendarValue}
        , showDateInput: showDateInput
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          className = _props2.className,
          placeholder = _props2.placeholder,
          icon = _props2.icon,
          iconRight = _props2.iconRight,
          disabled = _props2.disabled,
          showTime = _props2.showTime;
      var value = this.state.value;

      var classes = (0, _classnames2.default)(prefixCls + '-datePicker-input', className);
      return _react2.default.createElement(
        _Picker2.default,
        {
          animation: 'slide-up',
          disabled: disabled,
          calendar: this.renderCalendar(),
          value: value
          // value={value || now}
          , onChange: this.onChange
        },
        function (_ref) {
          var value = _ref.value;

          return _react2.default.createElement(_Input2.default, {
            className: classes,
            placeholder: placeholder,
            value: value && value.format(getFormat(showTime)) || '',
            icon: icon || null,
            iconRight: iconRight || null,
            disabled: disabled,
            readOnly: true
          });
        }
      );
    }
  }]);

  return DatePicker;
}(_react2.default.Component);

DatePicker.propTypes = {
  defaultValue: _react2.default.PropTypes.object,
  // defaultCalendarValue: React.PropTypes.object,
  prefixCls: _react2.default.PropTypes.string,
  className: _react2.default.PropTypes.string,
  disabled: _react2.default.PropTypes.bool,
  showTime: _react2.default.PropTypes.bool,
  showDateInput: _react2.default.PropTypes.bool,
  isDisabledBefore: _react2.default.PropTypes.bool,
  iconRight: _react2.default.PropTypes.bool,
  icon: _react2.default.PropTypes.string
};
DatePicker.defaultProps = {
  prefixCls: 'ult',
  placeholder: "请选择日期",
  // defaultValue: null,
  // defaultCalendarValue: {defaultCalendarValue},
  disabled: false,
  showTime: false,
  showDateInput: false,
  isDisabledBefore: true
};
exports.default = DatePicker;