'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _RangeCalendar = require('rc-calendar/lib/RangeCalendar');

var _RangeCalendar2 = _interopRequireDefault(_RangeCalendar);

var _Picker = require('rc-calendar/lib/Picker');

var _Picker2 = _interopRequireDefault(_Picker);

var _zh_CN = require('rc-calendar/lib/locale/zh_CN');

var _zh_CN2 = _interopRequireDefault(_zh_CN);

var _Panel = require('rc-time-picker/lib/Panel');

var _Panel2 = _interopRequireDefault(_Panel);

require('./datePicker.less');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

require('moment/locale/zh-cn');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 09:59:54 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

// import 'rc-calendar/assets/index.css';

// import 'rc-time-picker/assets/index.css';


// import 'moment/locale/en-gb';

var formatStr = 'YYYY-MM-DD HH:mm:ss';

function getFormat(time) {
  return time ? formatStr : 'YYYY-MM-DD';
}

var now = (0, _moment2.default)();
now.locale('zh-cn').utcOffset(8);

var defaultCalendarValue = now.clone();
// defaultCalendarValue.add(-1, 'month');

var timePickerElement = _react2.default.createElement(_Panel2.default, {
  defaultValue: [(0, _moment2.default)('00:00:00', 'HH:mm:ss'), (0, _moment2.default)('23:59:59', 'HH:mm:ss')]
});

function disabledDate(current) {
  if (!current) {
    // allow empty select
    return false;
  }
  var date = (0, _moment2.default)();
  date.hour(0);
  date.minute(0);
  date.second(0);
  return current.isBefore(date); // can not select days before today
}

function format(v, time) {
  return v ? v.format(getFormat(time)) : '';
}

function isValidRange(v) {
  return v && v[0] && v[1];
}

var RangePicker = function (_React$Component) {
  _inherits(RangePicker, _React$Component);

  function RangePicker(props) {
    _classCallCheck(this, RangePicker);

    var _this = _possibleConstructorReturn(this, (RangePicker.__proto__ || Object.getPrototypeOf(RangePicker)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    _this.state = {
      value: [],
      startValue: '',
      endValue: ''
    };
    return _this;
  }

  _createClass(RangePicker, [{
    key: 'onChange',
    value: function onChange(value) {
      var startValue = isValidRange(value) && format(value[0], this.props.showTime) || '';
      var endValue = isValidRange(value) && format(value[1], this.props.showTime) || '';
      this.setState({ value: value, startValue: startValue, endValue: endValue });
      if ("onChange" in this.props) {
        this.props.onChange(value, [startValue, endValue]);
      }
    }
  }, {
    key: 'renderCalendar',
    value: function renderCalendar() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          dateInputPlaceholder = _props.dateInputPlaceholder,
          showTime = _props.showTime,
          showToday = _props.showToday,
          showOk = _props.showOk;

      return _react2.default.createElement(_RangeCalendar2.default, {
        className: prefixCls + '-datePicker-calendar',
        dateInputPlaceholder: dateInputPlaceholder,
        locale: _zh_CN2.default,
        formatter: getFormat(showTime),
        defaultValue: [now, now.clone().add(1, 'months')],
        showOk: showOk,
        showToday: showToday,
        disabledDate: disabledDate
        // disabledTime={disabledTime}
        , timePicker: showTime ? timePickerElement : null
      });
    }
  }, {
    key: 'renderInput',
    value: function renderInput() {
      var _classnames;

      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          className = _props2.className,
          icon = _props2.icon,
          iconRight = _props2.iconRight,
          disabled = _props2.disabled,
          showTime = _props2.showTime;
      var _state = this.state,
          startValue = _state.startValue,
          endValue = _state.endValue;

      var classes = (0, _classnames3.default)(prefixCls + '-input ' + prefixCls + '-rangePicker-input', (_classnames = {}, _defineProperty(_classnames, prefixCls + '-rangePicker-input-disabled', disabled), _defineProperty(_classnames, prefixCls + '-input-icon', !!icon), _defineProperty(_classnames, prefixCls + '-input-icon-right', iconRight), _classnames), className);
      return function () {
        return _react2.default.createElement(
          'span',
          { className: classes },
          !!icon ? _react2.default.createElement('i', { className: 'iconfont icon-' + icon }) : null,
          _react2.default.createElement('input', {
            type: 'text',
            className: prefixCls + '-rangePicker-input-start',
            placeholder: '\u5F00\u59CB\u65E5\u671F',
            disabled: disabled,
            readOnly: true,
            value: startValue
          }),
          _react2.default.createElement('input', {
            type: 'text',
            className: prefixCls + '-rangePicker-input-end',
            placeholder: '\u7ED3\u675F\u65E5\u671F',
            disabled: disabled,
            readOnly: true,
            value: endValue
          })
        );
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var value = this.state.value;

      return _react2.default.createElement(
        _Picker2.default,
        {
          value: value,
          onChange: this.onChange,
          animation: 'slide-up',
          calendar: this.renderCalendar()
        },
        this.renderInput()
      );
    }
  }]);

  return RangePicker;
}(_react2.default.Component);

RangePicker.propTypes = {
  prefixCls: _react2.default.PropTypes.string,
  className: _react2.default.PropTypes.string,
  dateInputPlaceholder: _react2.default.PropTypes.array,
  showToday: _react2.default.PropTypes.bool,
  showTime: _react2.default.PropTypes.bool,
  // showWeekNumber: React.PropTypes.bool,
  showOk: _react2.default.PropTypes.bool,
  showClear: _react2.default.PropTypes.bool,
  onChange: _react2.default.PropTypes.func
};
RangePicker.defaultProps = {
  prefixCls: 'ult',
  dateInputPlaceholder: ['选择开始日期', '选择结束日期'],
  showTime: false,
  showOk: false,
  showToday: false
};
exports.default = RangePicker;