'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./dialog.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by ssehacker on 2016/10/19. 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Dialog = function (_React$Component) {
  _inherits(Dialog, _React$Component);

  function Dialog() {
    _classCallCheck(this, Dialog);

    return _possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).apply(this, arguments));
  }

  _createClass(Dialog, [{
    key: 'abort',
    value: function abort() {
      if (this.props.abort) {
        this.props.abort.call(this);
      }
    }
  }, {
    key: 'confirm',
    value: function confirm() {
      if (this.props.confirm) {
        this.props.confirm.call(this);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var me = this;
      var _props = this.props,
          prefixCls = _props.prefixCls,
          title = _props.title,
          titleNone = _props.titleNone,
          buttonNone = _props.buttonNone;

      var children = _react2.default.cloneElement(me.props.children, {
        ref: function ref(node) {
          _this2.form = node;
        }
      });
      return _react2.default.createElement(
        'div',
        { ref: function ref(node) {
            _this2.dialog = node;
          },
          className: (0, _classnames2.default)(prefixCls + '-ui-dialog', this.props.className),
          style: this.props.style || {}
        },
        titleNone ? null : _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(prefixCls + '-ui-dialog-header') },
          _react2.default.createElement(
            'h3',
            null,
            title
          )
        ),
        _react2.default.createElement(
          'a',
          { className: (0, _classnames2.default)(prefixCls + '-ui-dialog-close') },
          ' ',
          _react2.default.createElement('i', { className: 'iconfont icon-error', onClick: me.abort.bind(me) })
        ),
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(prefixCls + '-ui-dialog-content') },
          children
        ),
        buttonNone ? null : _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(prefixCls + '-ui-dialog-btn') },
          _react2.default.createElement(
            _Button2.default,
            { className: (0, _classnames2.default)({ hidden: !me.props.abortTitle }),
              onClick: me.abort.bind(me),
              type: 'default'
            },
            me.props.abortTitle
          ),
          _react2.default.createElement(
            _Button2.default,
            { onClick: me.confirm.bind(me), type: 'primary' },
            me.props.confirmTitle
          )
        )
      );
    }
  }]);

  return Dialog;
}(_react2.default.Component);

Dialog.defaultProps = {
  title: 'Dialog title',
  confirmTitle: '确定',
  // abortTitle: '取消',
  className: '',
  prefixCls: 'ult'
};
Dialog.propTypes = {
  title: _react2.default.PropTypes.string.isRequired,
  confirm: _react2.default.PropTypes.func,
  abort: _react2.default.PropTypes.func,
  confirmTitle: _react2.default.PropTypes.string,
  abortTitle: _react2.default.PropTypes.string,
  className: _react2.default.PropTypes.string,
  style: _react2.default.PropTypes.object,
  prefixCls: _react2.default.PropTypes.string
};


function dialog(element, props) {
  var prefixCls = 'ult';
  props = props || {};
  var wrapper = document.createElement('div');

  wrapper.className = prefixCls + '-ui-dialog-wrap';

  wrapper.style.height = '100vh';
  wrapper.style.width = '100vw';

  wrapper = document.body.appendChild(wrapper);

  var cleanup = function cleanup() {
    ReactDOM.unmountComponentAtNode(wrapper);
    setTimeout(function () {
      wrapper.remove();
    }, 0);
  };
  var abort = props.abort;
  props.abort = function () {
    if (abort) {
      abort.call(this);
    }
    cleanup();
  };

  var confirm = props.confirm;
  props.confirm = function () {
    if (confirm) {
      confirm.call(this);
    }
    cleanup();
  };

  var dialogEle = _react2.default.createElement(
    Dialog,
    props,
    element
  );

  ReactDOM.render(dialogEle, wrapper);
}

exports.default = dialog;