'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _dropdownMenu = require('./dropdownMenu');

var _dropdownMenu2 = _interopRequireDefault(_dropdownMenu);

var _dropdownMenuItem = require('./dropdownMenuItem');

var _dropdownMenuItem2 = _interopRequireDefault(_dropdownMenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:00:08 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _this.state = {
      isFlag: false
    };
    _this.handleCollapse = _this.handleCollapse.bind(_this);
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('click', this.handleCollapse);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.handleCollapse);
    }
  }, {
    key: 'handleClick',
    value: function handleClick(callback, name, e) {
      if (typeof callback == 'function') {
        callback(e, name);
        return;
      }
    }
  }, {
    key: 'handleToggle',
    value: function handleToggle(e) {
      e.preventDefault();
      e.nativeEvent.stopImmediatePropagation();
      var isFlag = this.state.isFlag;
      this.setState({
        isFlag: !isFlag
      });
    }
  }, {
    key: 'handleDropDown',
    value: function handleDropDown(e) {
      e.preventDefault();
      e.nativeEvent.stopImmediatePropagation();
      this.setState({
        isFlag: true
      });
    }
  }, {
    key: 'handleDropUp',
    value: function handleDropUp(e) {
      e.preventDefault();
      e.nativeEvent.stopImmediatePropagation();
      this.setState({
        isFlag: false
      });
    }
  }, {
    key: 'handleCollapse',
    value: function handleCollapse(e) {
      if (this.state && this.state.isFlag) {
        this.setState({
          isFlag: false
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          title = _props.title,
          prefixCls = _props.prefixCls,
          options = _props.options,
          disabled = _props.disabled,
          btnSize = _props.btnSize,
          text = _props.text,
          btnType = _props.btnType,
          style = _props.style,
          className = _props.className,
          placement = _props.placement,
          trigger = _props.trigger;

      var me = this;
      return _react2.default.createElement(
        _dropdownMenu2.default,
        {
          title: title,
          prefixCls: prefixCls,
          disabled: disabled,
          size: btnSize,
          text: text,
          type: btnType,
          className: className,
          style: style,
          placement: placement,
          trigger: trigger,
          isFlag: me.state.isFlag,
          collapse: me.handleCollapse.bind(me),
          toggle: me.handleToggle.bind(me),
          dropdown: me.handleDropDown.bind(me),
          dropup: me.handleDropUp.bind(me)
        },
        options.map(function (item, index) {
          return _react2.default.createElement(
            _dropdownMenuItem2.default,
            {
              key: index,
              onClick: me.handleClick.bind(me, item.callback, item.name),
              collapse: me.handleCollapse.bind(me),
              disabled: item.disabled,
              subOptions: item.subOptions || undefined
            },
            item.name
          );
        })
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  className: _react2.default.PropTypes.string,
  prefixCls: _react2.default.PropTypes.string,
  options: _react2.default.PropTypes.array,
  title: _react2.default.PropTypes.string,
  style: _react2.default.PropTypes.string,
  btnSize: _react2.default.PropTypes.oneOf(['large', 'small']),
  btnType: _react2.default.PropTypes.oneOf(['primary', 'default', 'dashed', 'success', 'warning', 'danger']),
  placement: _react2.default.PropTypes.oneOf(['topLeft', 'topRight', 'topCenter', 'bottomLeft', 'bottomRight', 'bottomCenter']),
  trigger: _react2.default.PropTypes.oneOf(['click', 'hover']),
  text: _react2.default.PropTypes.bool
};
Dropdown.defaultProps = {
  title: '下拉列表',
  disabled: false,
  prefixCls: 'ult'
};
exports.default = Dropdown;