'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./dropdown.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:00:32 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var DropdownMenu = function (_React$Component) {
    _inherits(DropdownMenu, _React$Component);

    function DropdownMenu() {
        _classCallCheck(this, DropdownMenu);

        return _possibleConstructorReturn(this, (DropdownMenu.__proto__ || Object.getPrototypeOf(DropdownMenu)).apply(this, arguments));
    }

    _createClass(DropdownMenu, [{
        key: 'handleClick',
        value: function handleClick(e) {
            if (this.props.trigger !== "hover") {
                this.props.toggle(e);
            }
        }
    }, {
        key: 'handleEnter',
        value: function handleEnter(e) {
            if (this.props.trigger == "hover") {
                this.props.dropdown(e);
            }
        }
    }, {
        key: 'handleLeave',
        value: function handleLeave(e) {
            if (this.props.trigger == "hover") {
                this.props.dropup(e);
            }
        }
    }, {
        key: 'renderTittle',
        value: function renderTittle() {
            var _props = this.props,
                type = _props.type,
                title = _props.title,
                disabled = _props.disabled,
                text = _props.text,
                size = _props.size,
                isFlag = _props.isFlag;

            var icon = isFlag ? 'up' : 'down';

            if (!text) {
                return _react2.default.createElement(_Button2.default, { type: type, name: title, icon: icon, disabled: disabled, size: size, onClick: this.handleClick.bind(this), iconRight: true });
            }
            return _react2.default.createElement(
                'a',
                { onClick: this.handleClick.bind(this) },
                title,
                isFlag ? _react2.default.createElement('i', { className: 'iconfont icon-up' }) : _react2.default.createElement('i', { className: 'iconfont icon-down' })
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                title = _props2.title,
                prefixCls = _props2.prefixCls,
                options = _props2.options,
                className = _props2.className,
                style = _props2.style,
                isFlag = _props2.isFlag,
                placement = _props2.placement;

            var classes = (0, _classnames3.default)(prefixCls + '-dropdown', className);
            var menuClses = (0, _classnames3.default)(prefixCls + '-dropdown-Menu', _defineProperty({}, prefixCls + '-dropdown-Menu-' + placement, !!placement));
            return _react2.default.createElement(
                'div',
                {
                    className: classes,
                    onMouseEnter: this.handleEnter.bind(this),
                    onMouseLeave: this.handleLeave.bind(this)
                },
                this.renderTittle(),
                isFlag ? _react2.default.createElement(
                    'ul',
                    { className: menuClses },
                    this.props.children
                ) : null
            );
        }
    }]);

    return DropdownMenu;
}(_react2.default.Component);

DropdownMenu.propTypes = {
    trigger: _react2.default.PropTypes.string,
    title: _react2.default.PropTypes.string,
    prefixCls: _react2.default.PropTypes.string,
    className: _react2.default.PropTypes.string,
    isFlag: _react2.default.PropTypes.bool,
    disabled: _react2.default.PropTypes.bool,
    text: _react2.default.PropTypes.bool,
    collapse: _react2.default.PropTypes.func,
    dropdown: _react2.default.PropTypes.func,
    dropup: _react2.default.PropTypes.func,
    toggle: _react2.default.PropTypes.func,
    size: _react2.default.PropTypes.string,
    type: _react2.default.PropTypes.string,
    placement: _react2.default.PropTypes.string
};
DropdownMenu.defaultProps = {
    text: false,
    type: "default"
};
exports.default = DropdownMenu;