'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./dropdown.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:00:41 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var DropdownMenuItem = function (_React$Component) {
    _inherits(DropdownMenuItem, _React$Component);

    function DropdownMenuItem() {
        _classCallCheck(this, DropdownMenuItem);

        return _possibleConstructorReturn(this, (DropdownMenuItem.__proto__ || Object.getPrototypeOf(DropdownMenuItem)).apply(this, arguments));
    }

    _createClass(DropdownMenuItem, [{
        key: 'handleClick',
        value: function handleClick(e) {
            var _props = this.props,
                onClick = _props.onClick,
                collapse = _props.collapse,
                disabled = _props.disabled;

            if (disabled) {
                e.nativeEvent.stopImmediatePropagation();
                return;
            }
            collapse(e);
            onClick(e);
        }
    }, {
        key: 'handleClickSubItem',
        value: function handleClickSubItem(callback, name, e) {
            var _props2 = this.props,
                collapse = _props2.collapse,
                disabled = _props2.disabled;

            if (disabled) {
                e.nativeEvent.stopImmediatePropagation();
                return;
            }
            collapse(e);
            callback(e, name);
            return;
        }
    }, {
        key: 'renderSubMenu',
        value: function renderSubMenu() {
            var _this2 = this;

            var subOptions = this.props.subOptions;

            return _react2.default.createElement(
                'ul',
                { className: 'sub-menu' },
                subOptions.map(function (option, index) {
                    return _react2.default.createElement(
                        'li',
                        { key: index },
                        _react2.default.createElement(
                            'a',
                            { href: option.href || "javascript:;", onClick: _this2.handleClickSubItem.bind(_this2, option.callback, option.name) },
                            option.name
                        )
                    );
                })
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                active = _props3.active,
                disabled = _props3.disabled,
                className = _props3.className,
                style = _props3.style,
                onClick = _props3.onClick,
                href = _props3.href,
                subOptions = _props3.subOptions;


            return _react2.default.createElement(
                'li',
                {
                    className: (0, _classnames2.default)(className, { active: active, disabled: disabled }),
                    style: style
                },
                _react2.default.createElement(
                    'a',
                    { href: href, onClick: this.handleClick.bind(this) },
                    name || this.props.children,
                    ' ',
                    subOptions ? _react2.default.createElement('i', { className: 'iconfont icon-right' }) : null
                ),
                subOptions ? this.renderSubMenu() : null
            );
        }
    }]);

    return DropdownMenuItem;
}(_react2.default.Component);

DropdownMenuItem.propTypes = {
    children: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.element]),
    className: _react2.default.PropTypes.string,
    active: _react2.default.PropTypes.bool,
    href: _react2.default.PropTypes.string,
    disabled: _react2.default.PropTypes.bool,
    onSelect: _react2.default.PropTypes.func,
    onClick: _react2.default.PropTypes.func,
    collapse: _react2.default.PropTypes.func,
    subOptions: _react2.default.PropTypes.array
};
DropdownMenuItem.defaultProps = {
    divider: false,
    disabled: false,
    children: '列表项',
    href: 'javascript:;'
};
exports.default = DropdownMenuItem;