'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _formsyReact = require('formsy-react');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _Textarea = require('../Textarea');

var _Textarea2 = _interopRequireDefault(_Textarea);

require('./form.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:02:02 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var HOC = _formsyReact2.default.HOC;

var TextareaForm = function (_React$Component) {
  _inherits(TextareaForm, _React$Component);

  function TextareaForm(props) {
    _classCallCheck(this, TextareaForm);

    var _this = _possibleConstructorReturn(this, (TextareaForm.__proto__ || Object.getPrototypeOf(TextareaForm)).call(this, props));

    var _this$props = _this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className;

    _this.state = {
      classes: (0, _classnames2.default)(prefixCls + '-form-group', className),
      errorMessage: null
    };
    _this.validClass = '';
    return _this;
  }

  _createClass(TextareaForm, [{
    key: 'changeValue',
    value: function changeValue(event) {
      this.props.setValue(event.currentTarget.value);
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          className = _props.className,
          showRequired = _props.showRequired,
          showError = _props.showError,
          getValue = _props.getValue;

      this.validClass = showRequired() ? getValue() == '' ? 'required' : '' : showError() ? 'error' : '';
      this.setState({
        classes: (0, _classnames2.default)(prefixCls + '-form-group', className, this.validClass),
        errorMessage: this.validClass == 'required' ? this.props.label + '\u4E0D\u80FD\u4E3A\u7A7A\uFF01' : this.props.getErrorMessage()
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          name = _props2.name,
          type = _props2.type,
          label = _props2.label,
          isRequired = _props2.isRequired,
          readOnly = _props2.readOnly,
          disabled = _props2.disabled,
          placeholder = _props2.placeholder,
          icon = _props2.icon,
          addon = _props2.addon;
      var _state = this.state,
          errorMessage = _state.errorMessage,
          classes = _state.classes;


      return _react2.default.createElement(
        'div',
        { className: classes },
        _react2.default.createElement(_Label2.default, {
          name: label,
          require: isRequired()
        }),
        _react2.default.createElement(_Textarea2.default, {
          type: type || 'text',
          name: name,
          onChange: this.changeValue.bind(this),
          onBlur: this.handleBlur.bind(this),
          value: this.props.getValue(),
          disabled: disabled || readOnly || false,
          placeholder: placeholder || '',
          addon: addon || null
        }),
        _react2.default.createElement(
          'span',
          { className: 'validation-error validation-textarea-error' },
          errorMessage
        )
      );
    }
  }]);

  return TextareaForm;
}(_react2.default.Component);

TextareaForm.propTypes = {
  className: _react2.default.PropTypes.string,
  prefixCls: _react2.default.PropTypes.string
};
TextareaForm.defaultProps = {
  prefixCls: "ult"
};
exports.default = HOC(TextareaForm);