'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

require('./index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:02:14 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var stringOrNumber = _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]);
var objectOrNumber = _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.object, _react2.default.PropTypes.number]);

var Col = function (_React$Component) {
  _inherits(Col, _React$Component);

  function Col() {
    _classCallCheck(this, Col);

    return _possibleConstructorReturn(this, (Col.__proto__ || Object.getPrototypeOf(Col)).apply(this, arguments));
  }

  _createClass(Col, [{
    key: 'render',
    value: function render() {
      var _this2 = this,
          _classnames;

      var props = this.props;
      var _props = this.props,
          span = _props.span,
          order = _props.order,
          offset = _props.offset,
          push = _props.push,
          pull = _props.pull,
          className = _props.className,
          style = _props.style,
          children = _props.children,
          prefixCls = _props.prefixCls;


      var mediaClassObj = {};
      ['xs', 'sm', 'md', 'lg', 'xl'].forEach(function (media) {
        var _Object$assign;

        var mediaProps = {};
        if (typeof _this2.props[media] === 'number') {
          mediaProps.span = _this2.props[media];
        } else if (_typeof(_this2.props[media]) === 'object') {
          mediaProps = _this2.props[media] || {};
        }

        mediaClassObj = Object.assign({}, mediaClassObj, (_Object$assign = {}, _defineProperty(_Object$assign, prefixCls + '-' + media + '-' + mediaProps.span, mediaProps.span !== undefined), _defineProperty(_Object$assign, prefixCls + '-' + media + '-order-' + mediaProps.order, mediaProps.order || mediaProps.order === 0), _defineProperty(_Object$assign, prefixCls + '-' + media + '-offset-' + mediaProps.offset, mediaProps.offset || mediaProps.offset === 0), _defineProperty(_Object$assign, prefixCls + '-' + media + '-push-' + mediaProps.push, mediaProps.push || mediaProps.push === 0), _defineProperty(_Object$assign, prefixCls + '-' + media + '-pull-' + mediaProps.pull, mediaProps.pull || mediaProps.pull === 0), _Object$assign));
      });

      var classes = (0, _classnames3.default)((_classnames = {}, _defineProperty(_classnames, prefixCls + '-' + span, span !== undefined), _defineProperty(_classnames, prefixCls + '-order-' + order, order), _defineProperty(_classnames, prefixCls + '-offset-' + offset, offset), _defineProperty(_classnames, prefixCls + '-push-' + push, push), _defineProperty(_classnames, prefixCls + '-pull-' + pull, pull), _classnames), className, mediaClassObj);

      return _react2.default.createElement(
        'div',
        { className: classes, style: style },
        children
      );
    }
  }]);

  return Col;
}(_react2.default.Component);

Col.propTypes = {
  span: stringOrNumber,
  order: stringOrNumber,
  offset: stringOrNumber,
  push: stringOrNumber,
  pull: stringOrNumber,
  className: _react2.default.PropTypes.string,
  style: _react2.default.PropTypes.object,
  children: _react2.default.PropTypes.node,
  xs: objectOrNumber,
  sm: objectOrNumber,
  md: objectOrNumber,
  lg: objectOrNumber,
  xl: objectOrNumber
};
Col.defaultProps = {
  prefixCls: 'ult-col'
};
exports.default = Col;