'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

require('./layout.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 17:54:15 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


function generator(props) {
  return function (Basic) {
    return function (_React$Component) {
      _inherits(_class, _React$Component);

      function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
      }

      _createClass(_class, [{
        key: 'render',
        value: function render() {
          var prefixCls = props.prefixCls;

          return _react2.default.createElement(Basic, _extends({ prefixCls: prefixCls }, this.props));
        }
      }]);

      return _class;
    }(_react2.default.Component);
  };
}

var Basic = function (_React$Component2) {
  _inherits(Basic, _React$Component2);

  function Basic() {
    _classCallCheck(this, Basic);

    return _possibleConstructorReturn(this, (Basic.__proto__ || Object.getPrototypeOf(Basic)).apply(this, arguments));
  }

  _createClass(Basic, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          className = _props.className,
          style = _props.style,
          children = _props.children,
          others = _objectWithoutProperties(_props, ['prefixCls', 'className', 'style', 'children']);

      var hasSider = void 0;
      _react2.default.Children.forEach(children, function (child) {
        if (child && child.type && child.type.name == "Sider") {
          hasSider = true;
        }
      });
      var divCls = (0, _classnames3.default)(className, prefixCls, _defineProperty({}, prefixCls + '-has-sider', hasSider));
      return _react2.default.createElement(
        'div',
        _extends({ className: divCls, style: style }, others),
        children
      );
    }
  }]);

  return Basic;
}(_react2.default.Component);

Basic.propTypes = {
  prefixCls: _react2.default.PropTypes.string,
  className: _react2.default.PropTypes.string,
  style: _react2.default.PropTypes.object
};


var Layout = generator({
  prefixCls: 'ult-layout'
})(Basic);

var Header = generator({
  prefixCls: 'ult-layout-header'
})(Basic);

var Footer = generator({
  prefixCls: 'ult-layout-footer'
})(Basic);

var Content = generator({
  prefixCls: 'ult-layout-content'
})(Basic);

Layout.Header = Header;
Layout.Footer = Footer;
Layout.Content = Content;

exports.default = Layout;