'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

require('./panel.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:05:42 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Panel = function (_React$Component) {
  _inherits(Panel, _React$Component);

  function Panel(props) {
    _classCallCheck(this, Panel);

    var _this = _possibleConstructorReturn(this, (Panel.__proto__ || Object.getPrototypeOf(Panel)).call(this, props));

    _this.state = {
      isFlag: false
    };
    return _this;
  }

  _createClass(Panel, [{
    key: 'handleCollapse',
    value: function handleCollapse() {
      var isFlag = this.state.isFlag;
      this.setState({
        isFlag: !isFlag
      });
    }
  }, {
    key: 'renderFooter',
    value: function renderFooter() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          footer = _props.footer;

      return footer !== undefined ? _react2.default.createElement(
        'div',
        { className: (0, _classnames4.default)(prefixCls + '-panel-footer') },
        footer
      ) : null;
    }
  }, {
    key: 'renderCollapse',
    value: function renderCollapse() {
      var prefixCls = this.props.prefixCls;

      var clazzIcon = this.state.isFlag ? 'add' : 'minus';
      return _react2.default.createElement(_Button2.default, {
        type: 'default',
        icon: clazzIcon,
        className: (0, _classnames4.default)(prefixCls + '-panel-collapse'),
        onClick: this.handleCollapse.bind(this)
      });
    }
  }, {
    key: 'renderContent',
    value: function renderContent() {
      var _props2 = this.props,
          prefixCls = _props2.prefixCls,
          children = _props2.children;

      var isFlag = this.state.isFlag;
      return isFlag ? null : _react2.default.createElement(
        'div',
        { className: (0, _classnames4.default)(prefixCls + '-panel-content') },
        children
      );
    }
  }, {
    key: 'renderTitleOfString',
    value: function renderTitleOfString() {
      var _props3 = this.props,
          prefixCls = _props3.prefixCls,
          title = _props3.title,
          collapse = _props3.collapse;
      var isFlag = this.state.isFlag;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames4.default)(prefixCls + '-panel-heading', _defineProperty({}, prefixCls + '-border-collapse', isFlag)) },
        _react2.default.createElement(
          'h4',
          { className: (0, _classnames4.default)(prefixCls + '-panel-title') },
          title
        ),
        collapse ? this.renderCollapse() : null
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          prefixCls = _props4.prefixCls,
          className = _props4.className,
          title = _props4.title,
          type = _props4.type;

      var classes = (0, _classnames4.default)(prefixCls + '-panel', _defineProperty({}, prefixCls + '-panel-' + type, type), className);
      return _react2.default.createElement(
        'div',
        { className: classes },
        typeof title === 'string' ? this.renderTitleOfString() : title,
        this.renderContent(),
        this.renderFooter()
      );
    }
  }]);

  return Panel;
}(_react2.default.Component);

Panel.propTypes = {
  type: _react2.default.PropTypes.oneOf(['primary', 'success', 'warning', 'danger']),
  children: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.element, _react2.default.PropTypes.array]).isRequired,
  title: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.element, _react2.default.PropTypes.node]),
  className: _react2.default.PropTypes.string,
  prefixCls: _react2.default.PropTypes.string,
  footer: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.element]),
  collapse: _react2.default.PropTypes.bool
};
Panel.defaultProps = {
  prefixCls: 'ult',
  title: '面板',
  children: '这是一个Panel面板',
  collapse: false
};
exports.default = Panel;