'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

require('./Progress.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:06:09 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var ProgressBar = function (_React$Component) {
  _inherits(ProgressBar, _React$Component);

  function ProgressBar(props) {
    _classCallCheck(this, ProgressBar);

    var _this = _possibleConstructorReturn(this, (ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).call(this, props));

    _this.state = {
      type: _this.props.type || 'primary'
    };
    return _this;
  }

  _createClass(ProgressBar, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.dynamic) {
        var percent = nextProps.percent;
        var room = nextProps.room;
        var used = 100 - room;
        switch (true) {
          case percent + used >= 96:
            this.setState({
              type: "danger"
            });
            break;
          case percent + used >= 70:
            this.setState({
              type: "warning"
            });
            break;
          default:
            this.setState({
              type: this.props.type || 'normal'
            });
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var _props = this.props,
          percent = _props.percent,
          prefixCls = _props.prefixCls;
      var type = this.state.type;

      var status = null;
      switch (type) {
        case 'info':
          status = '（信息）';
          break;
        case 'warning':
          status = '（警告）';
          break;
        case 'success':
          status = '（成功）';
          break;
        case 'danger':
          status = '（危险）';
          break;
        default:
          status = '';
      };

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames3.default)((_classnames = {}, _defineProperty(_classnames, prefixCls + '-progress-bar', true), _defineProperty(_classnames, prefixCls + '-progress-bar-' + type, true), _classnames)), style: { width: percent + '%' } },
        _react2.default.createElement(
          'span',
          { className: 'sr-only' },
          percent,
          '% \u5B8C\u6210',
          status
        )
      );
    }
  }]);

  return ProgressBar;
}(_react2.default.Component);

ProgressBar.propTypes = {
  type: _react2.default.PropTypes.oneOf(['primary', 'info', 'warning', 'success', 'danger']),
  dynamic: _react2.default.PropTypes.bool,
  percent: _react2.default.PropTypes.number,
  room: _react2.default.PropTypes.number,
  prefixCls: _react2.default.PropTypes.string
};
ProgressBar.defaultProps = {
  room: 100,
  prefixCls: 'ult'
};
exports.default = ProgressBar;