'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Select = require('../Select');

var _Select2 = _interopRequireDefault(_Select);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:06:28 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var InputGroup = _Input2.default.InputGroup;
var Option = _Select2.default.Option;

var Search = function (_React$Component) {
	_inherits(Search, _React$Component);

	function Search(props) {
		_classCallCheck(this, Search);

		var _this = _possibleConstructorReturn(this, (Search.__proto__ || Object.getPrototypeOf(Search)).call(this, props));

		_this.state = {
			value: '',
			key: _this.props.option[0] || ''
		};
		_this.onSelect = _this.onSelect.bind(_this);
		_this.onChange = _this.onChange.bind(_this);
		_this.onKeyUp = _this.onKeyUp.bind(_this);
		_this.handleSearch = _this.handleSearch.bind(_this);
		return _this;
	}

	_createClass(Search, [{
		key: 'onSelect',
		value: function onSelect(value) {
			this.setState({
				key: value
			});
		}
	}, {
		key: 'onChange',
		value: function onChange(e) {
			var value = e.target.value;
			this.setState({
				value: value
			});
		}
	}, {
		key: 'onKeyUp',
		value: function onKeyUp(e) {
			if (e.keyCode == '13') {
				this.handleSearch();
			}
		}
	}, {
		key: 'handleSearch',
		value: function handleSearch() {
			var _props = this.props,
			    onSearch = _props.onSearch,
			    option = _props.option;
			var _state = this.state,
			    key = _state.key,
			    value = _state.value;

			var searchKeywords = option.length > 0 ? {
				key: key,
				value: value
			} : value;
			if (onSearch && searchKeywords) {
				onSearch(searchKeywords);
			}
		}
	}, {
		key: 'renderSelectOption',
		value: function renderSelectOption() {
			var _props2 = this.props,
			    option = _props2.option,
			    disabled = _props2.disabled;

			var defaultValue = option[0];
			return _react2.default.createElement(
				_Select2.default,
				{
					defaultValue: defaultValue,
					disabled: disabled || false,
					onChange: this.onSelect
				},
				option.map(function (item, index) {
					return _react2.default.createElement(
						Option,
						{ key: index, value: item, text: item },
						item
					);
				})
			);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props3 = this.props,
			    prefixCls = _props3.prefixCls,
			    className = _props3.className,
			    style = _props3.style,
			    placeholder = _props3.placeholder,
			    option = _props3.option,
			    btnName = _props3.btnName,
			    disabled = _props3.disabled;
			var _state2 = this.state,
			    value = _state2.value,
			    key = _state2.key;

			var icon = btnName ? null : "search";
			var classes = (0, _classnames2.default)(prefixCls + '-search', className);
			return _react2.default.createElement(
				'div',
				{ className: classes },
				_react2.default.createElement(
					InputGroup,
					null,
					option.length > 0 ? this.renderSelectOption() : null,
					_react2.default.createElement(_Input2.default, { placeholder: placeholder, value: value, disabled: disabled || false, onChange: this.onChange, onKeyUp: this.onKeyUp }),
					_react2.default.createElement(_Button2.default, { icon: icon, name: btnName, disabled: disabled || false, onClick: this.handleSearch })
				)
			);
		}
	}]);

	return Search;
}(_react2.default.Component);

Search.propTypes = {
	prefixCls: _react2.default.PropTypes.string,
	className: _react2.default.PropTypes.string,
	style: _react2.default.PropTypes.object,
	placeholder: _react2.default.PropTypes.string,
	option: _react2.default.PropTypes.array,
	onSearch: _react2.default.PropTypes.func
};
Search.defaultProps = {
	prefixCls: 'ult',
	placeholder: '请输入要查询的关键字',
	option: []
};
exports.default = Search;