'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./slider.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SliderMark = function (_React$Component) {
    _inherits(SliderMark, _React$Component);

    function SliderMark() {
        _classCallCheck(this, SliderMark);

        return _possibleConstructorReturn(this, (SliderMark.__proto__ || Object.getPrototypeOf(SliderMark)).apply(this, arguments));
    }

    _createClass(SliderMark, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                className = _props.className,
                vertical = _props.vertical,
                marks = _props.marks,
                included = _props.included,
                upperBound = _props.upperBound,
                lowerBound = _props.lowerBound,
                max = _props.max,
                min = _props.min;

            var marksKeys = Object.keys(marks);
            var marksCount = marksKeys.length;
            var unit = 100 / (marksCount - 1);
            var markWidth = unit * 0.9;
            var range = max - min;
            var elements = marksKeys.map(parseFloat).sort(function (a, b) {
                return a - b;
            }).map(function (point) {
                var _classNames;

                var isActive = !included && point === upperBound || included && point <= upperBound && point >= lowerBound;
                var markClassName = classNames((_classNames = {}, _defineProperty(_classNames, className + '-text', true), _defineProperty(_classNames, className + '-text-active', isActive), _classNames));
                var bottomStyle = {
                    marginBottom: '-50%',
                    bottom: (point - min) / range * 100 + '%'
                };
                var leftStyle = {
                    width: markWidth + '%',
                    marginLeft: -markWidth / 2 + '%',
                    left: (point - min) / range * 100 + '%'
                };
                var style = vertical ? bottomStyle : leftStyle;
                var markPoint = marks[point];
                var markPointIsObject = (typeof markPoint === 'undefined' ? 'undefined' : _typeof(markPoint)) === 'object' && !_react2.default.isValidElement(markPoint);
                var markLabel = markPointIsObject ? markPoint.label : markPoint;
                var markStyle = markPointIsObject ? _extends({}, style, markPoint.style) : style;
                return _react2.default.createElement(
                    'span',
                    { className: markClassName, style: markStyle, key: point },
                    markLabel
                );
            });
            return _react2.default.createElement(
                'div',
                { className: className },
                elements
            );
        }
    }]);

    return SliderMark;
}(_react2.default.Component);

exports.default = SliderMark;