'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

require('./step.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 09:53:27 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var StepHead = function (_React$Component) {
    _inherits(StepHead, _React$Component);

    function StepHead() {
        _classCallCheck(this, StepHead);

        return _possibleConstructorReturn(this, (StepHead.__proto__ || Object.getPrototypeOf(StepHead)).apply(this, arguments));
    }

    _createClass(StepHead, [{
        key: 'getNavs',
        value: function getNavs() {
            var _props = this.props,
                panels = _props.panels,
                prefixCls = _props.prefixCls,
                activeIndex = _props.activeIndex;


            return _react2.default.Children.map(panels, function (child) {
                var _classnames;

                if (!child) {
                    return;
                }

                var order = parseInt(child.props.order, 10);

                var classes = (0, _classnames4.default)((_classnames = {}, _defineProperty(_classnames, prefixCls + '-step-nav-item', true), _defineProperty(_classnames, prefixCls + '-step-nav-item-active', activeIndex === order), _defineProperty(_classnames, prefixCls + '-step-nav-item-disabled', child.props.disabled), _classnames));

                var ref = {};
                if (activeIndex === order) {
                    ref.ref = 'activeItem';
                }

                return _react2.default.createElement(
                    'li',
                    _extends({
                        className: classes,
                        key: order
                    }, ref),
                    child.props.icon ? _react2.default.createElement('i', { className: 'iconfont icon-' + child.props.icon }) : null,
                    _react2.default.createElement(
                        'div',
                        { className: prefixCls + '-step-nav-item-title' },
                        child.props.title
                    )
                );
            });
        }
    }, {
        key: 'renderProgress',
        value: function renderProgress() {
            var _props2 = this.props,
                prefixCls = _props2.prefixCls,
                panels = _props2.panels,
                activeIndex = _props2.activeIndex,
                showProgress = _props2.showProgress;

            var total = panels.length;
            var bar_w = parseFloat(100 / total);
            var bar_left = activeIndex * bar_w;
            if (!showProgress) {
                return null;
            }
            return _react2.default.createElement(
                'div',
                { className: prefixCls + '-step-progress' },
                _react2.default.createElement('div', { className: prefixCls + '-step-progress-bar', style: { width: bar_w + '%', left: bar_left + '%' } })
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _props3 = this.props,
                prefixCls = _props3.prefixCls,
                showProgress = _props3.showProgress;

            return _react2.default.createElement(
                'div',
                { className: (0, _classnames4.default)(prefixCls + '-step-head', _defineProperty({}, prefixCls + '-step-head-progress', showProgress)) },
                _react2.default.createElement(
                    'ul',
                    { className: prefixCls + '-step-nav' },
                    this.getNavs()
                ),
                this.renderProgress()
            );
        }
    }]);

    return StepHead;
}(_react2.default.Component);

StepHead.propTypes = {
    prefixCls: _react2.default.PropTypes.string,
    panels: _react2.default.PropTypes.node,
    activeIndex: _react2.default.PropTypes.number
};
exports.default = StepHead;