'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

require('./switch.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:07:10 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Switch = function (_React$Component) {
  _inherits(Switch, _React$Component);

  function Switch(props) {
    _classCallCheck(this, Switch);

    var _this = _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).call(this, props));

    _this.state = {
      checked: props.checked ? !!props.checked : !!props.defaultChecked
    };
    return _this;
  }

  _createClass(Switch, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if ('checked' in nextProps) {
        this.setState({
          checked: !!nextProps.checked
        });
      }
    }
  }, {
    key: 'setChecked',
    value: function setChecked(checked) {
      if (!('checked' in this.props)) {
        this.setState({
          checked: checked
        });
      }
      if (this.props.onChange) {
        this.props.onChange(checked);
      }
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      var _props = this.props,
          disabled = _props.disabled,
          onClick = _props.onClick;

      var checked = !this.state.checked;
      if (!disabled) {
        this.setChecked(checked);
      }
      if (onClick) {
        onClick(checked);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var _props2 = this.props,
          className = _props2.className,
          prefixCls = _props2.prefixCls,
          disabled = _props2.disabled,
          size = _props2.size,
          square = _props2.square,
          checkedChildren = _props2.checkedChildren,
          unCheckedChildren = _props2.unCheckedChildren;

      var checked = this.state.checked;
      var classes = (0, _classnames3.default)((_classnames = {}, _defineProperty(_classnames, prefixCls + '-switch', true), _defineProperty(_classnames, prefixCls + '-switch-' + size, !!size), _defineProperty(_classnames, prefixCls + '-switch-square', !!square), _defineProperty(_classnames, prefixCls + '-switch-checked', checked), _defineProperty(_classnames, prefixCls + '-switch-disabled', disabled), _classnames), className);

      return _react2.default.createElement(
        'span',
        {
          className: classes,
          onClick: this.toggle.bind(this)
        },
        _react2.default.createElement(
          'span',
          { className: prefixCls + '-switch-inner' },
          checked ? checkedChildren : unCheckedChildren
        )
      );
    }
  }]);

  return Switch;
}(_react2.default.Component);

Switch.propTypes = {
  prefixCls: _react2.default.PropTypes.string,
  className: _react2.default.PropTypes.string,
  disabled: _react2.default.PropTypes.bool,
  size: _react2.default.PropTypes.oneOf(['large', 'small']),
  checkedChildren: _react2.default.PropTypes.string,
  unCheckedChildren: _react2.default.PropTypes.string,
  checked: _react2.default.PropTypes.bool,
  defaultChecked: _react2.default.PropTypes.bool,
  square: _react2.default.PropTypes.bool,
  onChange: _react2.default.PropTypes.func
};
Switch.defaultProps = {
  prefixCls: 'ult',
  disabled: false,
  defaultChecked: false,
  square: false,
  checkedChildren: '',
  unCheckedChildren: ''
};
exports.default = Switch;