'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('rc-time-picker/assets/index.css');

var _rcTimePicker = require('rc-time-picker');

var _rcTimePicker2 = _interopRequireDefault(_rcTimePicker);

require('./timePicker.less');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Author: SiMeiyu 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @Date: 2017-07-04 10:07:44 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var now = (0, _moment2.default)();

var TimePicker = function (_React$Component) {
  _inherits(TimePicker, _React$Component);

  function TimePicker(props) {
    _classCallCheck(this, TimePicker);

    var _this = _possibleConstructorReturn(this, (TimePicker.__proto__ || Object.getPrototypeOf(TimePicker)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    _this.state = {
      str: _this.props.showSecond ? 'HH:mm:ss' : 'HH:mm',
      value: _this.props.defaultValue || ''
    };
    return _this;
  }

  _createClass(TimePicker, [{
    key: 'onChange',
    value: function onChange(value) {
      var valueStr = value && value.format(this.state.str);
      if (this.props.onChange) {
        this.props.onChange(valueStr);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          className = _props.className,
          disabled = _props.disabled,
          defaultValue = _props.defaultValue,
          placeholder = _props.placeholder,
          props = _objectWithoutProperties(_props, ['prefixCls', 'className', 'disabled', 'defaultValue', 'placeholder']);

      var classes = (0, _classnames2.default)(prefixCls + '-timePicker', className);
      return _react2.default.createElement(_rcTimePicker2.default, _extends({
        className: classes,
        popupClassName: prefixCls + '-timePicker-panel',
        defaultValue: defaultValue,
        placeholder: placeholder,
        disabled: disabled
      }, props, {
        onChange: this.onChange
      }));
    }
  }]);

  return TimePicker;
}(_react2.default.Component);

TimePicker.propTypes = {
  defaultValue: _react2.default.PropTypes.object,
  prefixCls: _react2.default.PropTypes.string,
  className: _react2.default.PropTypes.string,
  placeholder: _react2.default.PropTypes.string,
  disabled: _react2.default.PropTypes.bool,
  // onChange: React.PropTypes.fucn,
  iconRight: _react2.default.PropTypes.bool,
  icon: _react2.default.PropTypes.string
};
TimePicker.defaultProps = {
  // defaultValue: now,
  // disabled: false,
  showSecond: true,
  prefixCls: 'ult',
  placeholder: '请选择时间'
};
exports.default = TimePicker;