'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

require('./Tooltip.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Popover = function (_React$Component) {
  _inherits(Popover, _React$Component);

  function Popover(props) {
    _classCallCheck(this, Popover);

    var _this = _possibleConstructorReturn(this, (Popover.__proto__ || Object.getPrototypeOf(Popover)).call(this, props));

    _this.state = {
      isFlag: false
    };
    _this.showAction = _this.showAction.bind(_this);
    _this.hideAction = _this.hideAction.bind(_this);
    return _this;
  }

  _createClass(Popover, [{
    key: 'handleToggle',
    value: function handleToggle(e) {
      e.preventDefault();
      e.nativeEvent.stopImmediatePropagation();
      var isFlag = this.state.isFlag;
      this.setState({
        isFlag: !isFlag
      });
    }
  }, {
    key: 'showAction',
    value: function showAction() {
      this.setState({
        isFlag: true
      });
    }
  }, {
    key: 'hideAction',
    value: function hideAction() {
      this.setState({
        isFlag: false
      });
    }
  }, {
    key: 'toggleAction',
    value: function toggleAction(e) {
      if (this.props.tipstype !== "hover") {
        this.handleToggle(e);
      }
    }
  }, {
    key: 'renderTittle',
    value: function renderTittle() {
      var popstype = this.props.popstype;

      var me = this;
      if (popstype == "click") {
        return _react2.default.createElement(
          'a',
          { onClick: this.toggleAction.bind(me) },
          this.props.children
        );
      } else {
        return _react2.default.createElement(
          'a',
          { onMouseEnter: this.showAction, onMouseLeave: this.hideAction },
          this.props.children
        );
      }
    }
  }, {
    key: 'renderTip',
    value: function renderTip() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          popstype = _props.popstype,
          poptitle = _props.poptitle,
          popplacement = _props.popplacement,
          popcontent = _props.popcontent;

      var isFlag = this.state.isFlag;
      var tipDiv = isFlag ? _react2.default.createElement(
        'div',
        { className: (0, _classnames3.default)(prefixCls + '-popover ' + prefixCls + '-popover-' + popplacement) },
        _react2.default.createElement('div', { className: (0, _classnames3.default)(prefixCls + '-arrow') }),
        _react2.default.createElement(
          'h3',
          { className: (0, _classnames3.default)(prefixCls + '-popover-title') },
          poptitle
        ),
        _react2.default.createElement(
          'div',
          { className: (0, _classnames3.default)(prefixCls + '-popover-content') },
          popcontent
        )
      ) : null;
      return tipDiv;
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var _props2 = this.props,
          className = _props2.className,
          popplacement = _props2.popplacement,
          prefixCls = _props2.prefixCls;

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames3.default)((_classnames = {}, _defineProperty(_classnames, prefixCls + '-tooltip', true), _defineProperty(_classnames, '' + className, !!className), _defineProperty(_classnames, prefixCls + '-tooltip-' + popplacement, !!popplacement), _classnames)) },
        this.renderTittle(),
        this.renderTip()
      );
    }
  }]);

  return Popover;
}(_react2.default.Component);

Popover.propTypes = {
  className: _react2.default.PropTypes.string,
  popplacement: _react2.default.PropTypes.oneOf(['bottom', 'top', 'left', 'right']),
  title: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.element, _react2.default.PropTypes.node]),
  popcontent: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.element, _react2.default.PropTypes.node]),
  prefixCls: _react2.default.PropTypes.string,
  popstype: _react2.default.PropTypes.oneOf(['hover', 'click'])
  // trigger: React.PropTypes.oneOf(['click', 'hover']),
};
Popover.defaultProps = {
  poptitle: '气泡卡片',
  popplacement: 'top',
  prefixCls: 'ult'
};
exports.default = Popover;